diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index dc143df72..ac9ff06ab 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -256,7 +256,7 @@ public class Chunk {
         return this.getBlockId(new ChunkTilePos(x, y, z));
     }
 
-    public @Nullable Block<?> getBlock(final @NotNull ChunkTilePosc tilePos) {
+    public @NotNull Block<?> getBlock(final @NotNull ChunkTilePosc tilePos) {
         return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
@@ -285,8 +285,8 @@ public class Chunk {
         final int currentId = section.getBlockId(new ChunkSectionTilePos(tilePos));
         final int currentData = section.getData(new ChunkSectionTilePos(tilePos));
 
-        final @Nullable Block<?> currentBlock = Blocks.getBlock(currentId);
-        final @Nullable Block<?> newBlock = Blocks.getBlock(id);
+        final @NotNull Block<?> currentBlock = Objects.requireNonNull(Blocks.getBlock(currentId));
+        final @NotNull Block<?> newBlock = Objects.requireNonNull(Blocks.getBlock(id));
 
         if (currentId == id && currentData == data) {
             return false;
@@ -296,7 +296,7 @@ public class Chunk {
         section.setData(new ChunkSectionTilePos(tilePos), data);
 
         final @NotNull TilePos worldPos = new TilePos(this.pos, tilePos);
-        if (!raw && currentBlock != null && !this.world.isClientSide) {
+        if (!raw && !this.world.isClientSide) {
             currentBlock.onRemoved(this.world, worldPos, currentData);
         }
 
@@ -314,7 +314,7 @@ public class Chunk {
         this.world.scheduleLightingUpdate(LightLayer.Block, worldPos);
         this.lightGaps(tilePos.x(), tilePos.z());
 
-        if (!raw && newBlock != null) {
+        if (!raw) {
             newBlock.onPlacedByWorld(this.world, worldPos);
         }
 
@@ -574,7 +574,7 @@ public class Chunk {
 
         if (tileEntity == null) {
             final @Nullable Block<?> block = this.getBlock(tilePos);
-            if (block == null || !block.isEntityTile) {
+            if (!block.isEntityTile) {
                 return null;
             } else {
                 block.onBlockPlacedByWorld(this.world, this.pos.x * CHUNK_SIZE_X + tilePos.x(), tilePos.y(), this.pos.z * CHUNK_SIZE_Z + tilePos.z());
@@ -616,7 +616,7 @@ public class Chunk {
         tileEntity.z = worldPos.z;
 
         final @Nullable Block<?> block = this.getBlock(tilePos);
-        if (block == null || !block.isEntityTile) {
+        if (!block.isEntityTile) {
             LOGGER.warn("Attempted to place a tile entity {} at {} {} {} where there was no tile entity block!", tileEntity.getClass(), worldPos.x, worldPos.y, worldPos.z);
             Thread.dumpStack();
         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index e2c46382c..739fdc602 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -10,12 +10,15 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.SeasonManager;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Objects;
+
 public class ChunkCache
     implements WorldSource {
     private final @NotNull ChunkPos origin;
@@ -25,7 +28,7 @@ public class ChunkCache
     private final int widthX;
     private final int widthZ;
 
-    public ChunkCache(final @NotNull World world, final @NotNull TilePos min, final @NotNull TilePos max, boolean priority) {
+    public ChunkCache(final @NotNull World world, final @NotNull TilePos min, final @NotNull TilePos max, final boolean priority) {
         this.world = world;
         this.origin = new ChunkPos(min);
 
@@ -60,29 +63,24 @@ public class ChunkCache
     }
 
     @Override
-    public int getBlockId(final @NotNull TilePosc tilePos) {
+    public @NotNull Block<?> getBlockType(final @NotNull TilePosc tilePos) {
         if (tilePos.y() < 0 || tilePos.y() >= this.getHeightBlocks()) {
-            return 0;
+            return Blocks.AIR;
         }
 
         final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
         if (cachePos.x < 0 || cachePos.x >= this.chunkArray.length || cachePos.z < 0 || cachePos.z >= this.chunkArray[cachePos.x].length) {
-            return 0;
+            return Blocks.AIR;
         }
 
         final @NotNull Chunk chunk = this.chunkArray[cachePos.x][cachePos.z];
-        return chunk.getBlockID(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
-    }
-
-    @Override
-    public @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos) {
-        return Blocks.getBlock(this.getBlockId(tilePos));
+        return chunk.getBlock(new ChunkTilePos(tilePos));
     }
 
     @Override
     public @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos) {
         final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
-        return this.chunkArray[cachePos.x][cachePos.z].getTileEntity(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
+        return this.chunkArray[cachePos.x][cachePos.z].getTileEntity(new ChunkTilePos(tilePos));
     }
 
     public boolean getBlockLitInteriorSurface(final @NotNull TilePosc tilePos) {
@@ -178,7 +176,7 @@ public class ChunkCache
             return brightness;
         } else {
             final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
-            return this.chunkArray[cachePos.x][cachePos.z].getRawBrightness(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1), this.world.skyDarken);
+            return this.chunkArray[cachePos.x][cachePos.z].getRawBrightness(new ChunkTilePos(tilePos), this.world.skyDarken);
         }
     }
 
@@ -188,30 +186,24 @@ public class ChunkCache
             return 0;
         } else {
             final @NotNull ChunkPos cachePos = new ChunkPos(tilePos).sub(this.origin.x, this.origin.z, new ChunkPos());
-            return this.chunkArray[cachePos.x][cachePos.z].getBlockMetadata(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
+            return this.chunkArray[cachePos.x][cachePos.z].getBlockData(new ChunkTilePos(tilePos));
         }
     }
 
     @Override
     public @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        if (block == null) {
-            return Materials.AIR;
-        } else {
-            return block.getMaterial();
-        }
+        return this.getBlockType(tilePos).getMaterial();
     }
 
     @Override
     public boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.isSolidRender();
+        return this.getBlockType(tilePos).isSolidRender();
     }
 
     @Override
     public boolean isBlockNormalCube(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
+        final @Nullable Block<?> block = this.getBlockType(tilePos);
+        return block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index fc844e0c7..4fe64ebe8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -78,9 +78,9 @@ public class ChunkSection {
     }
 
     public void setBlockId(final @NotNull ChunkSectionTilePosc sectionPos, final int id) {
-        assert id == 0 || Blocks.getBlock(id) != null;
+        assert Blocks.getBlock(id) != null;
 
-        if (!sectionPos.inBounds() || (this.blocks == null && id == 0)) {
+        if (!sectionPos.inBounds() || (this.blocks == null && id == Blocks.AIR.id())) {
             return;
         } else if (this.blocks == null) {
             this.blocks = new short[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java b/game/core/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
index ec62e906c..962050424 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
@@ -2,43 +2,33 @@ package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Blocks;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
-public class MissingBlockFixer
-{
+public final class MissingBlockFixer {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private static final short[] blocksArray;
+    private static final short @NotNull [] BLOCKS_ARRAY;
 
-    public MissingBlockFixer()
-    {
-    }
-
-    public static void fixMissingBlocks(short[] blocks)
-    {
-        for (int i = 0; i < blocks.length; i++)
-        {
-        	blocks[i] = blocksArray[blocks[i] & 0x3FFF];
-        }
-    }
-
-    static 
-    {
-        blocksArray = new short[Blocks.blocksList.length];
-        try
-        {
-            for (int i = 0; i < Blocks.blocksList.length; i++)
-            {
-                short id = (short)i;
-                if(id != 0 && Blocks.blocksList[id & 0x3FFF] == null)
-                {
-                	id = 0;
+    static {
+        BLOCKS_ARRAY = new short[Blocks.blocksList.length];
+        try {
+            for (int i = 0; i < Blocks.blocksList.length; i++) {
+                short id = (short) i;
+                if (Blocks.blocksList[id & 0x3FFF] == null) {
+                    id = (short) Blocks.AIR.id();
                 }
-                blocksArray[i] = id;
+                BLOCKS_ARRAY[i] = id;
             }
-        }
-        catch (Exception exception)
-        {
+        } catch (final Exception exception) {
             LOGGER.error("Exception initializing blocksArray!", exception);
         }
     }
+
+    public static void fixMissingBlocks(final short @NotNull [] blocks) {
+        for (int i = 0; i < blocks.length; i++) {
+            blocks[i] = BLOCKS_ARRAY[blocks[i] & 0x3FFF];
+        }
+    }
+
+    private MissingBlockFixer() { }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
index b40f6644a..5b68dbd53 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
@@ -8,6 +8,7 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Arrays;
+import java.util.Objects;
 
 public class ChunkGeneratorResult {
     private final short @NotNull [] @Nullable [] sectionBlocksArray;
@@ -16,54 +17,62 @@ public class ChunkGeneratorResult {
     public ChunkGeneratorResult() {
         this.sectionBlocksArray = new short[Chunk.CHUNK_SECTIONS][];
         this.numBlocksInSectionArray = new int[Chunk.CHUNK_SECTIONS];
-        Arrays.fill(this.numBlocksInSectionArray, 0);
     }
 
-    public void setBlock(int x, int y, int z, int id) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X ||
+    public void setBlock(final int x, final int y, final int z, final int id) {
+        if (
+            x < 0 || x >= Chunk.CHUNK_SIZE_X ||
             y < 0 || y >= (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) ||
             z < 0 || z >= Chunk.CHUNK_SIZE_Z ||
-            id < 0) return;
+            id < 0
+        ) {
+            return;
+        }
 
-        int section = y / ChunkSection.SECTION_SIZE_Y;
-        int cy = y % ChunkSection.SECTION_SIZE_Y;
+        final int section = y / ChunkSection.SECTION_SIZE_Y;
+        final int cy = y % ChunkSection.SECTION_SIZE_Y;
 
-        Block<?> newBlock = Blocks.getBlock(id);
+        final @NotNull Block<?> newBlock = Objects.requireNonNull(Blocks.getBlock(id));
 
         // If the array is null and we're only clearing a block, skip creating it; otherwise, create it
         if (this.sectionBlocksArray[section] == null) {
-            if (newBlock == null) {
-                return;
-            } else {
+            if (newBlock != Blocks.AIR) {
                 this.sectionBlocksArray[section] = new short[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
+            } else {
+                return;
             }
         }
 
         // Increment or decrement numBlocksInSection depending on whether we're setting or clearing a block
-        Block<?> currentBlock = Blocks.getBlock(getBlock(x, y, z));
-        if (newBlock == null && currentBlock != null) {
+        final @NotNull Block<?> currentBlock = Objects.requireNonNull(Blocks.getBlock(this.getBlock(x, y, z)));
+        if (newBlock == Blocks.AIR && currentBlock != Blocks.AIR) {
             this.numBlocksInSectionArray[section]--;
-        } else if (newBlock != null && currentBlock == null) {
+        } else if (newBlock != Blocks.AIR && currentBlock == Blocks.AIR) {
             this.numBlocksInSectionArray[section]++;
         }
 
         this.sectionBlocksArray[section][ChunkSection.makeBlockIndex(x, cy, z)] = (short) id;
     }
 
-    public int getBlock(int x, int y, int z) {
-        if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) || z < 0 || z >= Chunk.CHUNK_SIZE_Z)
+    public int getBlock(final int x, final int y, final int z) {
+        if (
+            x < 0 || x >= Chunk.CHUNK_SIZE_X ||
+            y < 0 || y >= (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) ||
+            z < 0 || z >= Chunk.CHUNK_SIZE_Z
+        ) {
             return 0;
+        }
 
-        int section = y / ChunkSection.SECTION_SIZE_Y;
-        int cy = y % ChunkSection.SECTION_SIZE_Y;
+        final int section = y / ChunkSection.SECTION_SIZE_Y;
+        final int cy = y % ChunkSection.SECTION_SIZE_Y;
 
         if (this.sectionBlocksArray[section] == null) {
-            return 0;
+            return Blocks.AIR.id();
         }
         return this.sectionBlocksArray[section][ChunkSection.makeBlockIndex(x, cy, z)];
     }
 
-    public short[] getSectionBlocks(int ySection) {
+    public short @Nullable [] getSectionBlocks(final int ySection) {
         if (ySection < 0 || ySection >= Chunk.CHUNK_SECTIONS) {
             return null;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
index e5c2fc578..90abe5021 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
@@ -4,6 +4,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3dc;
 import org.joml.Vector3fc;
 import org.joml.Vector3ic;
@@ -74,7 +75,11 @@ public interface TilePosc {
 
     @NotNull TilePos east(@NotNull TilePos dest);
 
-    default boolean equals(final @NotNull TilePosc tilePos) {
+    default boolean equals(final @Nullable TilePosc tilePos) {
+        if (tilePos == null) {
+            return false;
+        }
+
         return this.x() == tilePos.x() && this.y() == tilePos.y() && this.z() == tilePos.z();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 8fd2dce1c..0b8a7f2f2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -13,6 +13,7 @@ import net.minecraft.core.world.weather.Weathers;
 import net.minecraft.core.world.wind.WindProvider;
 import net.minecraft.core.world.wind.WindProviderGeneric;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -251,8 +252,8 @@ public abstract class WorldType {
         private int maxY = 255;
         private Integer maxPortalY = null;
         private int oceanY = 128;
-        private Block<?> oceanBlock = null;
-        private Block<?> fillerBlock = null;
+        private @Nullable Block<?> oceanBlock = null;
+        private @Nullable Block<?> fillerBlock = null;
         private int dayNightCycleTicks = Global.DAY_LENGTH_TICKS;
         private boolean mayRespawn = false;
         private boolean isRetro = false;
diff --git a/game/core/src/main/resources/lang/en_US/subtitles.lang b/game/core/src/main/resources/lang/en_US/subtitles.lang
index 3f4160498..28d05bfd8 100644
--- a/game/core/src/main/resources/lang/en_US/subtitles.lang
+++ b/game/core/src/main/resources/lang/en_US/subtitles.lang
@@ -1,40 +1,40 @@
 subtitles.mob.sheep=Sheep bleat
-subtitles.mob.chicken=Chicken clucking
+subtitles.mob.chicken=Chicken cluck
 subtitles.mob.chicken.hurt=Chicken hurt
 subtitles.mob.chicken.plop=Chicken plop
-subtitles.mob.pig=Pig oinking
+subtitles.mob.pig=Pig oink
 subtitles.mob.pig.death=Pig death
 subtitles.mob.wolf.howl=Wolf howl
-subtitles.mob.wolf.panting=Wolf panting
+subtitles.mob.wolf.panting=Wolf pant
 subtitles.mob.wolf.hurt=Wolf hurt
-subtitles.mob.wolf.bark=Wolf Bark
+subtitles.mob.wolf.bark=Wolf bark
 subtitles.mob.wolf.growl=Wolf growl
 subtitles.mob.wolf.death=Wolf death
 subtitles.mob.wolf.whine=Wolf whine
-subtitles.mob.wolf.shake=Wolf shaking
+subtitles.mob.wolf.shake=Wolf shake
 subtitles.mob.cow.hurt=Cow hurt
-subtitles.mob.cow=Cow mooing
-subtitles.mob.zombie=Zombie groans
+subtitles.mob.cow=Cow moo
+subtitles.mob.zombie=Zombie groan
 subtitles.mob.zombie.hurt=Zombie hurt
 subtitles.mob.zombie.death=Zombie death
 subtitles.mob.zombiepig.zpighurt=Zombie pigman hurt
-subtitles.mob.zombiepig.zpig=Zombie pigman groans
+subtitles.mob.zombiepig.zpig=Zombie pigman groan
 subtitles.mob.zombiepig.zpigdeath=Zombie pigman death
 subtitles.mob.zombiepig.zpigangry=Zombie pigman angry
-subtitles.mob.skeleton=Skeleton rattles
+subtitles.mob.skeleton=Skeleton rattle
 subtitles.mob.skeleton.death=Skeleton death
 subtitles.mob.skeleton.hurt=Skeleton hurt
 subtitles.mob.ghast.fireball=Ghast fireball
 subtitles.mob.ghast.moan=Ghast moan
 subtitles.mob.ghast.death=Ghast death
-subtitles.mob.ghast.scream=Ghast Scream
+subtitles.mob.ghast.scream=Ghast scream
 subtitles.mob.ghast.affectionate_scream=Ghast affectionate scream
 subtitles.mob.creeper=Creeper hiss
 subtitles.mob.creeper.death=Creeper death
 subtitles.mob.creeper.fuse=Creeper fuse
 subtitles.mob.spider.death=Spider death
 subtitles.mob.spider=Spider hiss
-subtitles.mob.ghast.charge=Ghast charging
+subtitles.mob.ghast.charge=Ghast charge
 subtitles.mob.slime.attack=Slime attack
 subtitles.mob.slime=Slime plop
 subtitles.mob.player.death=Player death
@@ -43,9 +43,9 @@ subtitles.mob.player.hurt=Player hurt
 subtitles.fall.small=Small fall
 subtitles.damage.fall.big=Big fall
 
-subtitles.liquid.water=Water flowing
+subtitles.liquid.water=Water flow
 subtitles.liquid.lava.pop=Lava pop
-subtitles.liquid.lava=Lava bubbling
+subtitles.liquid.lava=Lava bubble
 subtitles.liquid.splash=Water splash
 
 subtitles.portal.portal=Portal ambience
@@ -54,7 +54,7 @@ subtitles.portal.travel=Portal travel
 
 subtitles.item.pickup=Item pickup
 
-subtitles.random.fizz=Fizzing
+subtitles.random.fizz=Fizz
 subtitles.random.drr=Arrow drr
 subtitles.random.fuse=Fuse lit
 subtitles.random.skate=Skating
@@ -67,8 +67,8 @@ subtitles.random.bow=Bow shot
 subtitles.random.hurt=Hurt
 subtitles.random.splash=Splash
 subtitles.random.breath=Breath
-subtitles.random.bite=Player Eating
-subtitles.random.equip=Armor Equipped
+subtitles.random.bite=Player eat
+subtitles.random.equip=Armor equipped
 subtitles.random.stone_scrape=Stone scrape
 
 subtitles.note.snare=Note snare
@@ -93,8 +93,8 @@ subtitles.tile.piston.out=Piston extended
 subtitles.tile.piston.in=Piston retracted
 
 subtitles.tile.tnt.fuse=TNT lit
-subtitles.tile.sensor_block.sense=Mob sensed
-subtitles.tile.mobspawner.spawn=Mob spawned
+subtitles.tile.sensor_block.sense=Mob sense
+subtitles.tile.mobspawner.spawn=Mob spawn
 
 subtitles.tile.dispenser.click=Dispenser click
 subtitles.tile.dispenser.eject=Dispenser eject
@@ -106,4 +106,4 @@ subtitles.tile.activator.use=Activator use
 subtitles.hurt.flesh=Hurt flesh
 
 subtitles.fire.ignite=Fire lit
-subtitles.fire.fire=Fire crackling
+subtitles.fire.fire=Fire crackle
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index 5ae372bd0..86abe3c9b 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -100,12 +100,12 @@ public class PlayerServer extends Player implements ContainerListener {
         this.gamemode = gamemode;
 
         MenuInventory newContainer = gamemode.getInventoryMenu(this.inventory);
-        if (craftingInventory == inventorySlots)
+        if (containerMenu == inventoryMenu)
         {
-            craftingInventory = newContainer;
+            containerMenu = newContainer;
         }
-        inventorySlots = newContainer;
-        inventorySlots.addSlotListener(this);
+        inventoryMenu = newContainer;
+        inventoryMenu.addSlotListener(this);
         if (!gamemode.hasPlayerFlight())
         {
             noPhysics = false;
@@ -168,7 +168,7 @@ public class PlayerServer extends Player implements ContainerListener {
 
     public void setupCraftingInventoryListener()
     {
-        craftingInventory.addSlotListener(this);
+        containerMenu.addSlotListener(this);
     }
 
     @Override
@@ -182,7 +182,7 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         playerController.tick();
         ticksOfInvuln--;
-        craftingInventory.broadcastChanges();
+        containerMenu.broadcastChanges();
         for (int i = 0; i < 5; i++)
         {
             ItemStack itemstack = getEquipmentInSlot(i);
@@ -295,7 +295,7 @@ public class PlayerServer extends Player implements ContainerListener {
             boolean driftAllowed = mcServer.propertyManager.getBooleanProperty("allow-drift", false);
             if ((netherAllowed && targetDim == Dimension.NETHER) || (driftAllowed && targetDim == Dimension.DRIFT) || (targetDim != Dimension.NETHER && targetDim != Dimension.DRIFT))
             {
-                if (craftingInventory != inventorySlots)
+                if (containerMenu != inventoryMenu)
                 {
                     usePersonalCraftingInventory();
                 }
@@ -410,7 +410,7 @@ public class PlayerServer extends Player implements ContainerListener {
             }
         }
         super.onItemPickup(entity, item);
-        craftingInventory.broadcastChanges();
+        containerMenu.broadcastChanges();
     }
 
     @Override
@@ -494,10 +494,10 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_CRAFTING, "Crafting", 9));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuCrafting(inventory, world, tilePos);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuCrafting(inventory, world, tilePos);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     @Override
@@ -511,10 +511,10 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_GENERIC_CONTAINER, container.getNameTranslationKey(), container.getContainerSize()));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuContainer(inventory, container);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuContainer(inventory, container);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     public void displayChestScreen(Container container, double x, double y, double z) {
@@ -527,20 +527,20 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_FURNACE, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuFurnace(inventory, tileEntity);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuFurnace(inventory, tileEntity);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     @Override
     public void displayBlastFurnaceScreen(final TileEntityFurnaceBlast tileEntity) {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_BLAST_FURNACE, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuFurnaceBlast(inventory, tileEntity);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuFurnaceBlast(inventory, tileEntity);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     @Override
@@ -548,10 +548,10 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_DISPENSER, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuTrap(inventory, tileEntity);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuTrap(inventory, tileEntity);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     @Override
@@ -559,10 +559,10 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_ACTIVATOR, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuActivator(inventory, tileEntity);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuActivator(inventory, tileEntity);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
 
@@ -571,10 +571,10 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_TROMMEL, tileEntity.getNameTranslationKey(), tileEntity.getContainerSize()));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuTrommel(inventory, tileEntity);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuTrommel(inventory, tileEntity);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     @Override
@@ -582,20 +582,20 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketFlagOpen(currentWindowId, tileEntity.x, tileEntity.y, tileEntity.z));
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuFlag(inventory, tileEntity);
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuFlag(inventory, tileEntity);
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     public void displayGUIGuidebook()
     {
         getNextWindowId();
 
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = new MenuGuidebook();
-        craftingInventory.containerId = currentWindowId;
-        craftingInventory.addSlotListener(this);
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = new MenuGuidebook();
+        containerMenu.containerId = currentWindowId;
+        containerMenu.addSlotListener(this);
     }
 
     @Override
@@ -644,7 +644,7 @@ public class PlayerServer extends Player implements ContainerListener {
 
     public void usePersonalCraftingInventory()
     {
-        playerNetServerHandler.sendPacket(new PacketContainerClose(craftingInventory.containerId));
+        playerNetServerHandler.sendPacket(new PacketContainerClose(containerMenu.containerId));
         closeCraftingGui();
     }
 
@@ -663,8 +663,8 @@ public class PlayerServer extends Player implements ContainerListener {
 
     public void closeCraftingGui()
     {
-        craftingInventory.onCraftGuiClosed(this);
-        craftingInventory = inventorySlots;
+        containerMenu.onCraftGuiClosed(this);
+        containerMenu = inventoryMenu;
     }
 
     public void setMovementType(float f, float f1, boolean flag, boolean flag1, float f2, float f3)
